<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">

      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.production_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>

      <template slot="userInfo" slot-scope="scope">
        <div style="display: flex;">
          <div style="display: flex;justify-content: center;align-items: center;">
            <el-avatar size="large" :src="scope.row.loginWebVO.avatar"></el-avatar>
          </div>
           <div style="padding: 10px;">
             <div >昵称：{{scope.row.loginWebVO.nickName}}</div>
             <div>手机：{{scope.row.loginWebVO.phone}}</div>
           </div>
        </div>
      </template>

      <template slot="rank" slot-scope="scope">
        <el-tag effect="dark">
          {{scope.row.loginWebVO.rank}}
        </el-tag>
      </template>
      
      <template slot="urlsType" slot-scope="scope">
        <div v-if="scope.row.urlsType==0">图文</div>
        <div v-if="scope.row.urlsType==1">视频</div>
      </template>
      
      

      <template  slot="urls" slot-scope="scope">
        <el-image v-if="scope.row.urlsType==0" :preview-src-list="[scope.row.urls]" style="width: 50px;height: 50px;" :src="scope.row.urls"></el-image>
        <video style="width: 50px;height: 50px;" :src="scope.row.urls" v-if="scope.row.urlsType==1" :controls="false" :autoplay="true"></video>
      </template>
    </avue-crud>

  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/production/production";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        maskshow:false,
        urls:[],

        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          menu:false,
          memuLeft:true,
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          delBtn:true,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              hide:true,
              label: "用户id",
              prop: "userId",
              rules: [{
                required: true,
                message: "请输入用户id",
                trigger: "blur"
              }]
            },
            {
              label:"用户信息",
              slot:true,
              width: 200,
              prop:"userInfo"
            },
            {
              label: "排名",
              prop: "rank",
              slot:true
            },
            {
              label: "活动id",
              prop: "activityId",
              hide:true,
              rules: [{
                required: true,
                message: "请输入活动id",
                trigger: "blur"
              }]
            },
            {
              label: "参赛名字",
              prop: "personName",
              rules: [{
                required: true,
                message: "请输入参赛名字",
                trigger: "blur"
              }]
            },
            {
              label: "作品名称",
              prop: "title",
              rules: [{
                required: true,
                message: "请输入作品名称",
                trigger: "blur"
              }]
            },
            {
              label: "个人介绍/个人宣言",
              prop: "introduce",
              rules: [{
                required: true,
                message: "请输入个人介绍/个人宣言",
                trigger: "blur"
              }]
            },
            {
              label: "基本信息",
              prop: "personType",
              rules: [{
                required: true,
                message: "请输入基本信息",
                trigger: "blur"
              }]
            },
            {
              label: "作品资源",
              slot:true,
              prop: "urls",
              rules: [{
                required: true,
                message: "请输入作品资源",
                trigger: "blur"
              }]
            },
            {
              label: "资源类型",
              prop: "urlsType",
              slot:true
            },
            {
              label: "作品热力值",
              prop: "hotValue",
              rules: [{
                required: true,
                message: "请输入作品热力值",
                trigger: "blur"
              }]
            },
            {
              label: "作品封面",
              prop: "cover",
              rules: [{
                required: true,
                message: "请输入作品封面",
                trigger: "blur"
              }]
            },
            {
              label: "总浏览人数",
              prop: "visitTotal",
              rules: [{
                required: true,
                message: "请输入总浏览人数",
                trigger: "blur"
              }]
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.production_add, false),
          viewBtn: this.vaildData(this.permission.production_view, false),
          delBtn: this.vaildData(this.permission.production_delete, false),
          editBtn: this.vaildData(this.permission.production_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        this.query.activityId = this.$route.query.id;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      },
      viewUrls(urls){
        this.maskshow=true
        this.urls=urls
      }
    }
  };
</script>

<style scoped>

</style>
